/*
Demonstration of fast quadrature decoder using RP2040 (PicoPi)

2024-03-11
Michael Nowak
http://www.mino-elektronik.de
Alle Angaben ohne Gewaehr !
*/

#ifdef __cplusplus
extern "C" {
#endif
void init_pio1(void);
void init_qcnt(int);
void qcnt_preload(int);
int get_qcnt(void);
void set_qcnt_offset(int);
#ifdef __cplusplus
}
#endif
static int temp_q_cnt, q_cnt;

void setup() {
  Serial.begin(12345);
  init_qcnt(0);                       // preload value = 0
}

void loop() {
  q_cnt = get_qcnt();                 // read
  if(q_cnt != temp_q_cnt)  {          // compare new != old
    temp_q_cnt = q_cnt;               // old = new 
    Serial.println(q_cnt * 0.01, 2);  // scaled output via USB
  }
  delay(10);
}
